=== test/error/CMakeLists.txt ===
VIGRA_ADD_TEST(test_error test.cxx)
