=== test/imgproc/CMakeLists.txt ===
VIGRA_ADD_TEST(test_imgproc test.cxx LIBRARIES vigraimpex)

VIGRA_COPY_TEST_DATA(lenna128.xv lenna128rgb.xv splineimageview2.xv splineimageview3.xv splineimageview5.xv lenna42lin.xv lenna288neu.xv lenna42neu.xv lenna288rgbneu.xv lenna42rgbneu.xv lenna367FIR.xv lenna42FIR.xv lenna367IIR.xv lenna42IIR.xv lenna42linrgb.xv lennargb42FIR.xv lennargb42IIR.xv lenna_rotate.xv)
