=== debian/changelog ===
libvigraimpex (1.10.0+dfsg-3ubuntu2) trusty; urgency=medium

  * Build with -O2 on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 Feb 2014 16:34:51 +0100

libvigraimpex (1.10.0+dfsg-3ubuntu1) trusty; urgency=medium

  * Merge with Debian experimental to fix FTBFS; remaining changes:
    - Remove build dependency on libhdf5-serial-dev (universe).
    - debian/patches/no-hdf5.diff: Comment out additional methods
      requiring HDF5.
    - build using tiff5

 -- Barry Warsaw <barry@ubuntu.com>  Fri, 07 Feb 2014 18:43:30 -0500

libvigraimpex (1.10.0+dfsg-3) experimental; urgency=medium

  * QA upload.
  * Build with -pipe.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 27 Jan 2014 17:27:13 +0100

libvigraimpex (1.10.0+dfsg-2) experimental; urgency=medium

  * QA upload.
  * (Build-)Depend on libhdf5-dev instead of removed transitional package 
    libhdf5-serial-dev. Closes: #735569
  * (Build-)Depend on libtiff-dev instead of transitional package 
    libtiff4-dev.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 18 Jan 2014 16:23:38 +0100

libvigraimpex (1.10.0+dfsg-1) experimental; urgency=low

  * QA upload.
  * Update watchfile.
  * Use xz compression for source tarball.
  * New upstream version.
    + Drop patches previously pulled from upstream
      20_increased-tolerance-tests.diff
      ref-to-temporary-in-Sampler.diff
    + soname bumped, change package name.
    + Filename of upstream README changed.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 07 Dec 2013 19:56:15 +0100

libvigraimpex (1.9.0+dfsg-6ubuntu3) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 18:08:36 +0100

libvigraimpex (1.9.0+dfsg-6ubuntu2) saucy; urgency=low

  * Fix build failure with multi-arch'd libboost-python.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Sep 2013 22:06:59 +0200

libvigraimpex (1.9.0+dfsg-6ubuntu1) saucy; urgency=low

  * Merge with Debian; remaining changes:
    - Remove build dependency on libhdf5-serial-dev (universe).
    - debian/patches/no-hdf5.diff: Comment out additional methods
      requiring HDF5.
    - debian/libvigraimpex4.symbols: Mark additional HDF5 related symbols
      as optional since these won't appear in the library.
    - build using tiff5

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 02 Aug 2013 12:50:27 +0100

libvigraimpex (1.9.0-0ubuntu4) saucy; urgency=low

  * Cherry pick a patch from upstream to fix FTBFS against boost1.53 & gcc4.8.
  * Actually apply "Stop using .symbols files, and use dh_makeshlibs -V"
    from 1.8.0+dfsg-2 upload, but using ubuntu version number.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 22 May 2013 11:52:49 +0100

libvigraimpex (1.9.0-0ubuntu3) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:42 +0100
