=== debian/control ===
Source: libvigraimpex
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: dpkg-dev (>= 1.15.3~), debhelper (>= 7.0.50~),
  cmake,
  libfftw3-dev, libpng-dev, libjpeg-dev, libtiff5-dev,
  python-all-dev, python-numpy, libboost-python-dev, python-nose,
  libopenexr-dev
Build-Depends-Indep:
  python, python-sphinx, doxygen, texlive-latex-base, ghostscript
Build-Conflicts: autoconf2.13
X-Python-Version: >= 2.5
Standards-Version: 3.9.5
Homepage: http://hci.iwr.uni-heidelberg.de/vigra/

Package: libvigraimpex-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${python:Depends},
  libvigraimpex5 (= ${binary:Version}),
  libfftw3-dev, libpng12-dev, libjpeg-dev, libtiff5-dev
Suggests: libvigraimpex-doc
Description: development files for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 
 . 
 This package contains the header and development files needed to
 build programs and packages using VIGRA.

Package: libvigraimpex5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library 
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 

Package: libvigraimpex-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libvigraimpex-dev, python-vigra-doc
Description: Documentation for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 
 . 
 This package contains documentation for the VIGRA library.

Package: python-vigra
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Recommends: python-qt4
Suggests: python-vigra-doc, python-h5py
Description: Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package exports the functionality of the VIGRA library to Python.

Package: python-vigra-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python-vigra, libvigraimpex-doc
Description: Documentation for Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for Python bindings for the VIGRA library.
