=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg[0-9]*// \
http://hci.iwr.uni-heidelberg.de/vigra/ \
(?:.*/)vigra-([\d.]+)-src(?:-with-docu|).tar.gz
